var fs = require("fs");
var buttons = require("data/player_icon_buttons.json");
var construct = require("code/construct.js");

exports.run = function(window, document, $, project, misc, draw, frame){
	$("#player_icons li").removeClass("player_icon_select");
	
	if(!project.frames[frame.index].player_icons){
		project.frames[frame.index].player_icons = "classic";
	}

	var canvas = document.getElementById("canvas"),
		context = canvas.getContext("2d");
	
	$("#player_icons ol").on("click", "li", function(){
		var that = this;
		
		var type = $(that).attr('data-player');
		$("#x img").attr("src", "resources/images/xo/buttons/" + buttons[type].x);
		$("#o img").attr("src", "resources/images/xo/buttons/" + buttons[type].o);
		
		$("#player_icons ol li").removeClass("player_icon_select");
		$(that).addClass("player_icon_select");
		
		global.actions.push(new construct.action({
			type: "change_player_icons",
			frame_index: frame.index,
			old: project.frames[frame.index].player_icons
		}));
		
		project.frames[frame.index].player_icons = type;
		
		draw.log(context, document, project.frames[frame.index]);
		
		var pdf_ctx = document.getElementById("pdf_canvas").getContext("2d");
		draw.current_frame(frame.index, pdf_ctx, project.frames[frame.index], document);
		
		misc.saved = false;
		
	});
	
	$("#player_icons ol li").removeClass("player_icon_select");
	$("#player_icons ol li[data-player='" + project.frames[frame.index].player_icons + "']").addClass("player_icon_select");
	
};